#include "proc.h"

#include <glibtop.h>
#include <glibtop/cpu.h>
#include <glibtop/mem.h>
#include <glibtop/swap.h>

#include <stdio.h>

void
proc_read_cpu (ProcInfo *ps)
{
	glibtop_cpu cpu;
	int i;

	glibtop_get_cpu (&cpu);

	for (i=1; i<PROC_CPU_SIZE; i++)
		ps->cpu_last [i] = ps->cpu_now [i];

	ps->cpu_now [PROC_CPU_USER] = cpu.user;
	ps->cpu_now [PROC_CPU_NICE] = cpu.nice;
	ps->cpu_now [PROC_CPU_SYS]  = cpu.sys;
	ps->cpu_now [PROC_CPU_IDLE] = cpu.idle;

	for (i=1; i<PROC_CPU_SIZE; i++)
		ps->cpu [i] = ps->cpu_now [i] - ps->cpu_last [i];

	ps->cpu [PROC_CPU_TOTAL] = 
		ps->cpu [PROC_CPU_USER] +
		ps->cpu [PROC_CPU_NICE] +
		ps->cpu [PROC_CPU_SYS] +
		ps->cpu [PROC_CPU_IDLE];
}

void
proc_read_mem (ProcInfo *ps)
{
	glibtop_mem mem;
	glibtop_swap swap;

	glibtop_get_mem (&mem);

	ps->mem [PROC_MEM_TOTAL]  = mem.total;
	ps->mem [PROC_MEM_USED]   = mem.used;
	ps->mem [PROC_MEM_FREE]   = mem.free;
	ps->mem [PROC_MEM_SHARED] = mem.shared;
	ps->mem [PROC_MEM_BUF]    = mem.buffer;

	ps->mem [PROC_MEM_USER] = ps->mem [PROC_MEM_TOTAL]
		- ps->mem [PROC_MEM_FREE]
		- ps->mem [PROC_MEM_BUF]
		- ps->mem [PROC_MEM_SHARED];

	glibtop_get_swap (&swap);

	ps->swap [PROC_SWAP_TOTAL] = swap.total;
	ps->swap [PROC_SWAP_USED]  = swap.used;
	ps->swap [PROC_SWAP_FREE]  = swap.free;
}
